#include	<stdio.h>

__global__ void kernel ( int * data, int n )
{
	size_t index = threadIdx.x + blockIdx.x * blockDim.x;

	if ( index < n )
		data [index] = index;
}

int main ()
{
	int   * ptr;
	int	n = 1024*1024;		// # of elements
	int	blockSize = 1024;
	int	numBlocks = (n + blockSize - 1) / blockSize;
					// allocate managed memory
	cudaMallocManaged ( &ptr, n * sizeof ( int ) );

	kernel<<<numBlocks, blockSize>>> ( ptr, n );

	cudaDeviceSynchronize ();

	for ( int i = 0; i < n; i++ )
		if ( ptr [i] != i )
		{
			printf ( "Error at %d - %d\n", i, ptr [i] );
			return 1;
		}

	cudaFree ( ptr );

	printf ( "Success\n" );

	return 0;
}
